# This job will be pack build directory as zip file 
packaging-ui-zip:
  image: bytekode/alpine-toolchain:3.6.1
  tags:
    - docker-itsd-noproxy
  stage: mobileapp-packaging
  cache:
    key: ${CI_COMMIT_REF_SLUG}
    untracked: true
    policy: pull-push
  only:
    - /^sit[\/\-].+$/
    - /^qa[\/\-].+$/
    - /^prod[\/\-][\d]+(\.\d+){0,3}$/
  artifacts:
    name: ui-zip
    paths:
      - ${CI_PROJECT_NAME}.zip
  script:
    - ls -l build/
    - rm -f ${CI_PROJECT_NAME}.zip 2> /dev/null
    - mkdir -p mobileapp/${CI_PROJECT_NAME}
    - cp -r build/* mobileapp/${CI_PROJECT_NAME}/
    - ls -l mobileapp/${CI_PROJECT_NAME}
    - cd mobileapp && zip -r -9 ../${CI_PROJECT_NAME}.zip ${CI_PROJECT_NAME} && cd ../
    - rm -rf ./mobileapp
    - echo -e "UI zip file created. \nZip contents \n $(unzip -l ${CI_PROJECT_NAME}.zip)"
    - |
        \
        echo "Encrypting zip file.."
        openssl enc -aes-128-cbc -in ${CI_PROJECT_NAME}.zip -out ${CI_PROJECT_NAME}.zip.enc -K ${MOBILE_ZIP_KEY} -iv ${MOBILE_ZIP_IV}
        md5sum ${CI_PROJECT_NAME}.zip.enc > ${CI_PROJECT_NAME}.zip.enc.md5
        # rm -f ${CI_PROJECT_NAME}.zip
        echo -e "UI Artifact created. \n$(ls -l *.zip*)"

.init-ssh:
  tags:
    - docker-itsd-noproxy
  image: bytekode/sshclient
  before_script:
    - |
        \
        echo -e "Preparing ssh connection.."
        mkdir -p /root/.ssh/
        cat ${CD_SSH_CONFIG}|base64 -d > /root/.ssh/config
        chown root /root/.ssh/config
    - | 
        \
        # Preparing target directory
        # qa/* -> qa
        # prod/* -> prod
        echo -e "Preparing deployment directory.."
        export OVERLAY=$( echo ${CI_COMMIT_REF_NAME} | awk -F '[/-]' '{print $1}')
        export UPLOAD_DIR="/data/webserver/sftp/upload/${OVERLAY}/mobileapp/${CI_PIPELINE_ID}"
    
.mobileapp-deploy:
  extends: .init-ssh
  stage: mobileapp-deploy
  cache:
    key: ${CI_COMMIT_REF_SLUG}
    untracked: true
    policy: pull
  script:
    - |
        \
        echo -e "Uploading mobile artifacts to ${UPLOAD_DIR}.."
        sshpass -p${CD_SSH_PASSWORD} ssh dispatcher mkdir -p ${UPLOAD_DIR}
        sshpass -p${CD_SSH_PASSWORD} scp *.zip.enc* dispatcher:${UPLOAD_DIR}
        sshpass -p${CD_SSH_PASSWORD} ssh dispatcher touch ${UPLOAD_DIR}/deploy
        echo -e "Artifact files successful uploaded.\nContinue process deployment..."

